
/*
             Common Public License Version 0.5

             THE ACCOMPANYING PROGRAM IS PROVIDED UNDER THE TERMS OF
             THIS COMMON PUBLIC LICENSE ("AGREEMENT"). ANY USE,
             REPRODUCTION OR DISTRIBUTION OF THE PROGRAM CONSTITUTES
             RECIPIENT'S ACCEPTANCE OF THIS AGREEMENT.

             1. DEFINITIONS

             "Contribution" means: 
                   a) in the case of the initial Contributor, the
                   initial code and documentation distributed under
                   this Agreement, and 

                   b) in the case of each subsequent Contributor:
                   i) changes to the Program, and
                   ii) additions to the Program;

                   where such changes and/or additions to the Program
                   originate from and are distributed by that
                   particular Contributor. A Contribution 'originates'
                   from a Contributor if it was added to the Program
                   by such Contributor itself or anyone acting on such
                   Contributor's behalf. Contributions do not include
                   additions to the Program which: (i) are separate
                   modules of software distributed in conjunction with
                   the Program under their own license agreement, and
                   (ii) are not derivative works of the Program.


             "Contributor" means any person or entity that distributes
             the Program.

             "Licensed Patents " mean patent claims licensable by a
             Contributor which are necessarily infringed by the use or
             sale of its Contribution alone or when combined with the
             Program. 

             "Program" means the Contributions distributed in
             accordance with this Agreement.

             "Recipient" means anyone who receives the Program under
             this Agreement, including all Contributors.

             2. GRANT OF RIGHTS

                   a) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free copyright
                   license to reproduce, prepare derivative works of,
                   publicly display, publicly perform, distribute and
                   sublicense the Contribution of such Contributor, if
                   any, and such derivative works, in source code and
                   object code form.

                   b) Subject to the terms of this Agreement, each
                   Contributor hereby grants Recipient a
                   non-exclusive, worldwide, royalty-free patent
                   license under Licensed Patents to make, use, sell,
                   offer to sell, import and otherwise transfer the
                   Contribution of such Contributor, if any, in source
                   code and object code form. This patent license
                   shall apply to the combination of the Contribution
                   and the Program if, at the time the Contribution is
                   added by the Contributor, such addition of the
                   Contribution causes such combination to be covered
                   by the Licensed Patents. The patent license shall
                   not apply to any other combinations which include
                   the Contribution. No hardware per se is licensed
                   hereunder.

                   c) Recipient understands that although each
                   Contributor grants the licenses to its
                   Contributions set forth herein, no assurances are
                   provided by any Contributor that the Program does
                   not infringe the patent or other intellectual
                   property rights of any other entity. Each
                   Contributor disclaims any liability to Recipient
                   for claims brought by any other entity based on
                   infringement of intellectual property rights or
                   otherwise. As a condition to exercising the rights
                   and licenses granted hereunder, each Recipient
                   hereby assumes sole responsibility to secure any
                   other intellectual property rights needed, if any.

                   For example, if a third party patent license is
                   required to allow Recipient to distribute the
                   Program, it is Recipient's responsibility to
                   acquire that license before distributing the
                   Program.

                   d) Each Contributor represents that to its
                   knowledge it has sufficient copyright rights in its
                   Contribution, if any, to grant the copyright
                   license set forth in this Agreement.

             3. REQUIREMENTS

             A Contributor may choose to distribute the Program in
             object code form under its own license agreement, provided
             that:
                   a) it complies with the terms and conditions of
                   this Agreement; and

                   b) its license agreement:
                   i) effectively disclaims on behalf of all
                   Contributors all warranties and conditions, express
                   and implied, including warranties or conditions of
                   title and non-infringement, and implied warranties
                   or conditions of merchantability and fitness for a
                   particular purpose;

                   ii) effectively excludes on behalf of all
                   Contributors all liability for damages, including
                   direct, indirect, special, incidental and
                   consequential damages, such as lost profits;

                   iii) states that any provisions which differ from
                   this Agreement are offered by that Contributor
                   alone and not by any other party; and

                   iv) states that source code for the Program is
                   available from such Contributor, and informs
                   licensees how to obtain it in a reasonable manner
                   on or through a medium customarily used for
                   software exchange.

             When the Program is made available in source code form:
                   a) it must be made available under this Agreement;
                   and
                   b) a copy of this Agreement must be included with
                   each copy of the Program. 

             Contributors may not remove or alter any copyright notices
             contained within the Program.

             Each Contributor must identify itself as the originator of
             its Contribution, if any, in a manner that reasonably
             allows subsequent Recipients to identify the originator of
             the Contribution. 


             4. COMMERCIAL DISTRIBUTION

             Commercial distributors of software may accept certain
             responsibilities with respect to end users, business
             partners and the like. While this license is intended to
             facilitate the commercial use of the Program, the
             Contributor who includes the Program in a commercial
             product offering should do so in a manner which does not
             create potential liability for other Contributors.
             Therefore, if a Contributor includes the Program in a
             commercial product offering, such Contributor ("Commercial
             Contributor") hereby agrees to defend and indemnify every
             other Contributor ("Indemnified Contributor") against any
             losses, damages and costs (collectively "Losses") arising
             from claims, lawsuits and other legal actions brought by a
             third party against the Indemnified Contributor to the
             extent caused by the acts or omissions of such Commercial
             Contributor in connection with its distribution of the
             Program in a commercial product offering. The obligations
             in this section do not apply to any claims or Losses
             relating to any actual or alleged intellectual property
             infringement. In order to qualify, an Indemnified
             Contributor must: a) promptly notify the Commercial
             Contributor in writing of such claim, and b) allow the
             Commercial Contributor to control, and cooperate with the
             Commercial Contributor in, the defense and any related
             settlement negotiations. The Indemnified Contributor may
             participate in any such claim at its own expense.


             For example, a Contributor might include the Program in a
             commercial product offering, Product X. That Contributor
             is then a Commercial Contributor. If that Commercial
             Contributor then makes performance claims, or offers
             warranties related to Product X, those performance claims
             and warranties are such Commercial Contributor's
             responsibility alone. Under this section, the Commercial
             Contributor would have to defend claims against the other
             Contributors related to those performance claims and
             warranties, and if a court requires any other Contributor
             to pay any damages as a result, the Commercial Contributor
             must pay those damages.


             5. NO WARRANTY

             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, THE
             PROGRAM IS PROVIDED ON AN "AS IS" BASIS, WITHOUT
             WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR
             IMPLIED INCLUDING, WITHOUT LIMITATION, ANY WARRANTIES OR
             CONDITIONS OF TITLE, NON-INFRINGEMENT, MERCHANTABILITY OR
             FITNESS FOR A PARTICULAR PURPOSE. Each Recipient is solely
             responsible for determining the appropriateness of using
             and distributing the Program and assumes all risks
             associated with its exercise of rights under this
             Agreement, including but not limited to the risks and
             costs of program errors, compliance with applicable laws,
             damage to or loss of data, programs or equipment, and
             unavailability or interruption of operations. 

             6. DISCLAIMER OF LIABILITY
             EXCEPT AS EXPRESSLY SET FORTH IN THIS AGREEMENT, NEITHER
             RECIPIENT NOR ANY CONTRIBUTORS SHALL HAVE ANY LIABILITY
             FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
             OR CONSEQUENTIAL DAMAGES (INCLUDING WITHOUT LIMITATION
             LOST PROFITS), HOWEVER CAUSED AND ON ANY THEORY OF
             LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
             (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
             OF THE USE OR DISTRIBUTION OF THE PROGRAM OR THE EXERCISE
             OF ANY RIGHTS GRANTED HEREUNDER, EVEN IF ADVISED OF THE
             POSSIBILITY OF SUCH DAMAGES.

             7. GENERAL

             If any provision of this Agreement is invalid or
             unenforceable under applicable law, it shall not affect
             the validity or enforceability of the remainder of the
             terms of this Agreement, and without further action by the
             parties hereto, such provision shall be reformed to the
             minimum extent necessary to make such provision valid and
             enforceable.


             If Recipient institutes patent litigation against a
             Contributor with respect to a patent applicable to
             software (including a cross-claim or counterclaim in a
             lawsuit), then any patent licenses granted by that
             Contributor to such Recipient under this Agreement shall
             terminate as of the date such litigation is filed. In
             addition, If Recipient institutes patent litigation
             against any entity (including a cross-claim or
             counterclaim in a lawsuit) alleging that the Program
             itself (excluding combinations of the Program with other
             software or hardware) infringes such Recipient's
             patent(s), then such Recipient's rights granted under
             Section 2(b) shall terminate as of the date such
             litigation is filed.

             All Recipient's rights under this Agreement shall
             terminate if it fails to comply with any of the material
             terms or conditions of this Agreement and does not cure
             such failure in a reasonable period of time after becoming
             aware of such noncompliance. If all Recipient's rights
             under this Agreement terminate, Recipient agrees to cease
             use and distribution of the Program as soon as reasonably
             practicable. However, Recipient's obligations under this
             Agreement and any licenses granted by Recipient relating
             to the Program shall continue and survive. 

             Everyone is permitted to copy and distribute copies of
             this Agreement, but in order to avoid inconsistency the
             Agreement is copyrighted and may only be modified in the
             following manner. The Agreement Steward reserves the right
             to publish new versions (including revisions) of this
             Agreement from time to time. No one other than the
             Agreement Steward has the right to modify this Agreement.

             IBM is the initial Agreement Steward. IBM may assign the
             responsibility to serve as the Agreement Steward to a
             suitable separate entity. Each new version of the
             Agreement will be given a distinguishing version number.
             The Program (including Contributions) may always be
             distributed subject to the version of the Agreement under
             which it was received. In addition, after a new version of
             the Agreement is published, Contributor may elect to
             distribute the Program (including its Contributions) under
             the new version. Except as expressly stated in Sections
             2(a) and 2(b) above, Recipient receives no rights or
             licenses to the intellectual property of any Contributor
             under this Agreement, whether expressly, by implication,
             estoppel or otherwise. All rights in the Program not
             expressly granted under this Agreement are reserved.


             This Agreement is governed by the laws of the State of New
             York and the intellectual property laws of the United
             States of America. No party to this Agreement will bring a
             legal action under this Agreement more than one year after
             the cause of action arose. Each party waives its rights to
             a jury trial in any resulting litigation. 



*/

/* (C) COPYRIGHT International Business Machines Corp. 2001          */


/**********************************************************************

   CRYPTICA.C       (Part of CRYPTICA.DLL)

   Copyright (C) IBM Corporation 2000

        - The Host Library entry points
           . icaGetAdapterCount
           . icaGetAdapterID
           . icaGetVPD
           . icaOpenAdapter
           . icaCloseAdapter
           . icaRsaModExpo
           . icaRsaModCrt
           . icaDes
           . icaTDes
           . icaDesMac
           . icaTDesMac
           . icaSha1
           . icaRandomNumberGenerate


   Author: Joe Andruzzi

***********************************************************************/

#include <windows.h>
#include <winioctl.h>
#include <stdio.h>   // printf
#include "ica.h"
#include "icatypes.h"
#include "ica_api.h"        // Request packets from application
#include "ica_err.h"        // Error definitions




static unsigned char exp1087[] =

{
0x40, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
static SZ_EXP1087 = sizeof(exp1087);

static unsigned char exp1084[] =
{
0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
};
static SZ_EXP1084 = sizeof(exp1084);

static unsigned char three[] = { 0x03 };
static SZ_THREE = sizeof(three);
static unsigned char one[] = { 0x01 };
static SZ_ONE = sizeof(one);
/*----------------------------------------------------------------------
  mapSysErr
         - Maps an operating system error to a crypto error.
         - Returns the appropriate crypto error.
-----------------------------------------------------------------------*/
UINT  mapSysErr( ULONG  rc )
{


  return( HOST_OS_ERR | (rc & 0xFFFF) );      // Error reported by the OS


}

/************************************************************************
   normalize

   Input: msb_x --pointer to MSByte of x
         norm_a --pointer to byte length of x

   Output:
     pointer to first non-zero MSByte
     real byte length

*************************************************************************/
PUCHAR normalize(PUCHAR msb_x, unsigned int *norm_a)
{
 unsigned int sz_a;
 PUCHAR  msb_a;
 sz_a = *norm_a;
 msb_a = msb_x;
 //
 //Is the byte length non-zero and MSByte non-zero then done,
 //else search the length for the first non-zero byte
 //
 if((sz_a) && (!(*msb_a)))
 {
  while(sz_a)
  {
   if(*msb_x)
    break;
   else
   {
    msb_x++;
    sz_a--;
   }
  }
 }
 *norm_a = sz_a;
 return(msb_x);
}


/************************************************************************
   compareFast
   Input: msb_x --pointer to MSByte of x
          msb_y --pointer to MSByte of y
           sz_x --byte count of x (may include leading zeros)
           sz_y --byte count of y (may include leading zeros)
   Output:
     0  -> x==y
    -1  -> x<y
     1  -> x>y

*************************************************************************/
INT compareFast(PUCHAR msb_x, unsigned int sz_x,
                PUCHAR msb_y, unsigned int sz_y)
{

 
  unsigned int sz_t,sz_u;
  PUCHAR msb_t,msb_u;

  sz_t = sz_x;
  sz_u = sz_y;

  msb_t = normalize(msb_x,&sz_t);
  msb_u = normalize(msb_y,&sz_u);
  if (sz_t > sz_u)
   return(1);
  if (sz_u > sz_t)
   return(-1);
  //
  //Same size, if the sizes are zero then done,
  //else keep comparing from MSByte to LSByte
  //
  if(sz_t && sz_u)
  {
   do{
      if((*msb_t) != (*msb_u))
       break;
	  msb_t++;
	  msb_u++;
   }while(sz_t--);
   if(sz_t)
    if((*msb_t) > (*msb_u))
     return(1);
    else
     return(-1);
   else
    return(0);
  }
  return(0);
}

/************************************************************************
   verifyRSAModExpo

        Check the input parameters,key and user data consistency, these
        are hardware requirements that will cause hardware errors when
        parameters are out of bounds.


                 - Verify the supplied parameters
                 - Verify exponent and modulus are odd
                 - Verify input is less then modulus


*************************************************************************/
icaStatus_t verifyRSAModExpo(unsigned int          inputDataLength,
                             unsigned int          outputDataLength,
                             unsigned char         *pInputData,
                             ICA_KEY_RSA_MODEXPO   *pKeyModExpo)
{

  PUCHAR                  pUserData;
  PUCHAR                  pModulus;
  unsigned int            modulusByteLength;
  unsigned int            modulusHwByteLength;
  ICA_KEY_RSA_MODEXPO     keyME;              // need this to convert Big->little endian

 /***********************************************************
 ****BigEndian to Little Endian Conversion               ****
 **** Bit length to Byte length (round up)               ****
 **** OutputDataLength must be sufficient to hold result ****
 ************************************************************/
 REVERSE_UINT(&(keyME.modulusBitLength), &(pKeyModExpo->modulusBitLength));
 modulusByteLength = (keyME.modulusBitLength+7)/8;  // determine Modulus number of bytes

 if (modulusByteLength > outputDataLength)
 {
   printf("\n modulusByteLength(0x%08lx) outputDataLength(0x%08lx)", modulusByteLength,outputDataLength);
   return(HDDInvalidLength);
 }

 /***********************************************
 ****BigEndian to Little Endian Conversion *****
 **** Get the keyType                      *****
 ***********************************************/
 REVERSE_UINT(&(keyME.keyType), &(pKeyModExpo->keyType));

 if ((keyME.keyType != RSA_PUBLIC_MODULUS_EXPONENT) &&
     (keyME.keyType != RSA_PRIVATE_MODULUS_EXPONENT))
 {
    return(PKABadParm);
 }

 //
 // Is the supplied Token length less then the calculated length
 // rsaRef[index].keylength = nLength + expLength (supplied in token)
 // then add the non-key structure references(header+lengths+offsets)
 //
 REVERSE_UINT(&(keyME.keyLength), &(pKeyModExpo->keyLength));
 REVERSE_UINT(&(keyME.expLength), &(pKeyModExpo->expLength));
 REVERSE_UINT(&(keyME.nLength), &(pKeyModExpo->nLength));

 if(keyME.keyLength < (keyME.expLength + keyME.nLength +
                       SZ_HEADER_MODEXPO))
 {
   return(HDDInvalidLength);
 }
 //
 // Does the expLength & nLength meet the hardware requirements
 // all must be multiple of 32 bytes(256 bits)
 //
 modulusHwByteLength = ((modulusByteLength+31)/32)*32;
 if((keyME.expLength != modulusHwByteLength) ||
    (keyME.nLength != modulusHwByteLength))
 {
   return(HDDInvalidLength);
 }

 //
 //RSA Modular Exponentiation rules & hardware limits
 // x   exponent must be odd
 // x   modulus must be odd
 // x   0 <= input Message < Modulus
 //     0 <= exponent < 2**bit length---Not Implemented??
 //     0 <= modulus  < 2**bit length---Not Implemented??

 //
 // exponent odd?
 //
 REVERSE_UINT(&(keyME.expOffset), &(pKeyModExpo->expOffset));
 if (!(*((PUCHAR)pKeyModExpo + keyME.expOffset + (keyME.expLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // modulus odd?
 //
 REVERSE_UINT(&(keyME.nOffset), &(pKeyModExpo->nOffset));
 if (!(*((PUCHAR)pKeyModExpo + keyME.nOffset + (keyME.nLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // 0 <= input Message < Modulus?
 // Message & Modulus are BigEndian
 //
 //
 // find MSbyte of Modulus(note: may have leading zeros)
 // compare the value of Modulus to value of input data
 //
 pModulus = (PUCHAR)pKeyModExpo + keyME.nOffset;
 pUserData = pInputData;
 if((compareFast(pModulus,keyME.nLength,pUserData,inputDataLength)) <= 0)
 {
    return(PKABadParm);
 }

 return(HDDGood);
} // verifyRSAModExp

/************************************************************************
   verifyRSACrt
                 - Verify the RSA key & Data


*************************************************************************/
icaStatus_t verifyRSACrt(unsigned int          inputDataLength,
                         unsigned int          outputDataLength,
                         unsigned char         *pInputData,
                         ICA_KEY_RSA_CRT       *pKeyCrt)
{

  PUCHAR                  pPrimeP;
  PUCHAR                  pPrimeQ;
  PUCHAR                  qInverse;
  unsigned int            modulusByteLength;
  ICA_KEY_RSA_CRT         keyCRT;        // need this to convert Big->little endian

 /***********************************************************
 ****BigEndian to Little Endian Conversion               ****
 **** Bit length to Byte length (round up)               ****
 **** OutputDataLength must be sufficient to hold result ****
 ************************************************************/
 REVERSE_UINT(&(keyCRT.modulusBitLength), &(pKeyCrt->modulusBitLength));
 modulusByteLength = (keyCRT.modulusBitLength+7)/8;  // determine Modulus number of bytes

 if (modulusByteLength > outputDataLength)
 {
   return(HDDInvalidLength);
 }

 /***********************************************
 ****BigEndian to Little Endian Conversion *****
 **** Get the keyType                      *****
 ***********************************************/
 REVERSE_UINT(&(keyCRT.keyType), &(pKeyCrt->keyType));

 if (keyCRT.keyType != RSA_PKCS_PRIVATE_CHINESE_REMAINDER)
 {
    return(PKABadParm);
 }

 //
 // Is the supplied Token length less then the calculated length?
 //
 REVERSE_UINT(&(keyCRT.keyLength), &(pKeyCrt->keyLength));
 REVERSE_UINT(&(keyCRT.pLength), &(pKeyCrt->pLength));
 REVERSE_UINT(&(keyCRT.qLength), &(pKeyCrt->qLength));
 REVERSE_UINT(&(keyCRT.dpLength), &(pKeyCrt->dpLength));
 REVERSE_UINT(&(keyCRT.dqLength), &(pKeyCrt->dqLength));
 REVERSE_UINT(&(keyCRT.qInvLength), &(pKeyCrt->qInvLength));

 if(keyCRT.keyLength < (keyCRT.pLength + keyCRT.qLength +
                        keyCRT.dpLength + keyCRT.dqLength +
                        keyCRT.qInvLength +
                        SZ_HEADER_CRT))
 {
   return(HDDInvalidLength);
 }
 //
 //RSA CRT rules & hardware limits
 //
 //  x  p must be odd
 //  x  q must be odd
 //  x  dp must be odd
 //  x  dq must be odd
 //  x  p>q
 //  x  sizeof(p)+sizeof(q) <= modulus bit length
 //  x  3<=p<2**1087
 //  x  3<=q<2**1084
 //  x  1<=qInv<p
 //     1<=dp<(p-1)
 //     1<=dq,(q-1)
 //     0<=m<(p*q)
 //
 // prime p odd?
 //
 REVERSE_UINT(&(keyCRT.pOffset), &(pKeyCrt->pOffset));
 if (!(*((PUCHAR)pKeyCrt + keyCRT.pOffset + (keyCRT.pLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // prime q odd?
 //
 REVERSE_UINT(&(keyCRT.qOffset), &(pKeyCrt->qOffset));
 if (!(*((PUCHAR)pKeyCrt + keyCRT.qOffset + (keyCRT.qLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // subprime dp odd?
 //
 REVERSE_UINT(&(keyCRT.dpOffset), &(pKeyCrt->dpOffset));
 if (!(*((PUCHAR)pKeyCrt + keyCRT.dpOffset + (keyCRT.dpLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // subprime dq odd?
 //
 REVERSE_UINT(&(keyCRT.dqOffset), &(pKeyCrt->dqOffset));
 if (!(*((PUCHAR)pKeyCrt + keyCRT.dqOffset + (keyCRT.dqLength-1)) & 0x01))
 {
    return(PKABadParm);
 }
 //
 // p > q ?
 //
 // find MSbyte of p(note: may have leading zeros)
 //
 pPrimeP = (PUCHAR)pKeyCrt + keyCRT.pOffset;
 pPrimeQ = (PUCHAR)pKeyCrt + keyCRT.qOffset;
 if((compareFast(pPrimeP,keyCRT.pLength,pPrimeQ,keyCRT.qLength)) <= 0)
 {
    printf("\n FAIL p > q test");
    return(PKABadParm);
 }
 //
 //  sizeof(p)+sizeof(q) <= modulus bit length?
 //
 if((keyCRT.pLength + keyCRT.qLength) >  keyCRT.modulusBitLength)
 {
    printf("\n FAIL sizeof(p)+sizeof(q) <= modulus bit length?");
    return(PKABadParm);
 }
 //
 //    3<=p<2**1087?
 //
   if((compareFast(pPrimeP,keyCRT.pLength,exp1087,SZ_EXP1087)) >= 0)
   {
      printf("\n FAIL p > 2**1087");
      return(PKABadParm);
   }
   if((compareFast(pPrimeP,keyCRT.pLength,three,SZ_THREE)) < 0)
   {
      printf("\n FAIL p < 3");
      return(PKABadParm);
   }
 //
 //    3<=q<2**1084?
 //
   if((compareFast(pPrimeQ,keyCRT.qLength,exp1084,SZ_EXP1084)) >= 0)
   {
      printf("\n FAIL q > 2**1084 test");
      return(PKABadParm);
   }
   if((compareFast(pPrimeQ,keyCRT.qLength,three,SZ_THREE)) < 0)
   {
      printf("\n FAIL q < 3 test");
      return(PKABadParm);
   }
 //
 //    1<=qInv<p
 //
   REVERSE_UINT(&(keyCRT.qInvOffset), &(pKeyCrt->qInvOffset));
   qInverse = (PUCHAR)pKeyCrt + keyCRT.qInvOffset;
   if((compareFast(qInverse,keyCRT.qInvLength,pPrimeP,keyCRT.pLength)) >= 0)
   {
      printf("\n FAIL p > qInv test");
      return(PKABadParm);
   }
   if((compareFast(qInverse,keyCRT.qInvLength,one,SZ_ONE)) < 0)
   {
      printf("\n FAIL qInv > 1 test");
      return(PKABadParm);
   }

 return(HDDGood);
} // verifyRSAModCrt

/*----------------------------------------------------------------------
  openAdaptNum
       - Opens a specific adapter.
       - Returns the 'rc' (untouched) to the calling function.
----------------------------------------------------------------------*/
ULONG  openAdaptNum( icaAdapterNumber_t  AdapterNum,
                     HANDLE              *phHandle)
{

 HANDLE  hDriver;
 ULONG   rc;
 CHAR    AdaptName[] = { "\\\\.\\ICAx" };


 AdaptName[7] = AdapterNum+0x30;            // Set correct adapter number


 // Open the driver
 hDriver = CreateFile( AdaptName,                           // Adapter
                       GENERIC_READ | GENERIC_WRITE,        // access mode
                       FILE_SHARE_READ | FILE_SHARE_WRITE,  // share mode
                       NULL,                                // not inheritable
                       OPEN_EXISTING,                       // how to create
                       FILE_ATTRIBUTE_NORMAL |              // file attributes
                       FILE_FLAG_OVERLAPPED,                // file flags
                       NULL  );                             // template (?)


 if (hDriver == INVALID_HANDLE_VALUE)
    {
    rc = GetLastError();
    // printf("\n ICADLL Error Opening:  %s    rc = 0x%lX", AdaptName, rc);
    return( rc );
    }


 *phHandle = hDriver;


 return(0);

}




/***********************************************************************
*
* icaAdapterCount -
*
*     Public API to obtain the number of crypto adapters available.
*
*     Input:    pAdapterCount   = pointer to user count
*
*     Output:   pAdapterCount   = actual count is written to this address
*
*     Returns:  unsigned int = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaGetAdapterCount( icaAdapterNumber_t *pAdapterCount )
{
 HANDLE              hHandle;
 ULONG               cbReturned;
 ULONG               rc, rc2;
 BOOLEAN             success;
 icaAdapterNumber_t  i;


 // Need to open a working adapter to get the count info.
 for (i=0; i<CR_MAX_CARDS; i++)
    {
    rc = openAdaptNum( i, &hHandle );         // Open one of the adapters
    if (rc == 0)                              //   Open succesful?
       break;
    }

 if (rc)                                      // Cannot open any adapter!!??
    return( mapSysErr(rc) );                  //   Translate to Crypto error


 success = DeviceIoControl( hHandle,
                            (ULONG) IOCTL_CRYPTO_CNT,
                            NULL,                  // User to driver data
                            0,
                            pAdapterCount,         // Driver to user data
                            sizeof(icaAdapterNumber_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on DevIOCtl GETHWCNT   rc = 0x%X", rc );
    }


 rc2 = icaCloseAdapter( hHandle);  // Close the adapter


 if (rc)                                // Error getting count?
    return( mapSysErr(rc) );            //   Translate to Crypto error

 if (rc2)                               // Error closing?
    return( mapSysErr(rc2) );           //   Translate to Crypto error


 return(0);

}


/***********************************************************************
*
* icaGetAdapterID -
*
*     Public API to obtain the AdapterID data from its PCI configuration.
*
*     Input:    AdapterNum     = adapter number
*               pAdapterInfo   = pointer to AdapterID structure
*
*     Output:   pAdapterInfo   = actual ID data is written to this structure
*
*     Returns:  UINT = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaGetAdapterID( icaAdapterNumber_t  AdapterNum,
                                icaAdapterID_t     *pAdapterInfo)
{
 HANDLE              hHandle;
 ULONG               cbReturned;
 ULONG               rc, rc2;
 BOOLEAN             success;


 // Need to open the appropriate adapter to get the PCI data.
 rc = openAdaptNum( AdapterNum, &hHandle );   // Open the adapter

 if (rc)                                      // Cannot open the adapter!!??
    return( mapSysErr(rc) );                  //   Translate to Crypto error


 success = DeviceIoControl( hHandle,
                            (ULONG) IOCTL_CRYPTO_ADAPTERID,
                            NULL,                  // User to driver data
                            0,
                            pAdapterInfo,            // Driver to user data
                            sizeof(icaAdapterID_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on DevIOCtl GETADAPTERID   rc = 0x%X", rc );
    }


 rc2 = icaCloseAdapter( hHandle);  // Close the adapter


 if (rc)                                // Error getting AdapterID?
    return( mapSysErr(rc) );            //   Translate to Crypto error

 if (rc2)                               // Error closing?
    return( mapSysErr(rc2) );           //   Translate to Crypto error


 return(0);

}

/***********************************************************************
*
* icaGetVPD -
*
*     Public API to obtain the Vital Product data from an adapter.
*
*     Input:    AdapterNum     = adapter number
*               pAdapterInfo   = pointer to Adapter VPD structure
*
*     Output:   pAdapterInfo   = actual VPD data is written to this structure
*
*     Returns:  UINT = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaGetVPD( icaAdapterNumber_t  AdapterNum,
                          ICA_ADAPTER_VPD    *pAdapterInfo)
{
 HANDLE              hHandle;
 ULONG               cbReturned;
 ULONG               rc, rc2;
 BOOLEAN             success;


 // Need to open the appropriate adapter to get the PCI data.
 rc = openAdaptNum( AdapterNum, &hHandle );   // Open the adapter

 if (rc)                                      // Cannot open the adapter!!??
    return( mapSysErr(rc) );                  //   Translate to Crypto error


 success = DeviceIoControl( hHandle,
                            (ULONG) IOCTL_CRYPTO_ADAPTERVPD,
                            NULL,                  // User to driver data
                            0,
                            pAdapterInfo,          // Driver to user data
                            szVPD,
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on DevIOCtl GETADAPTERID   rc = 0x%X", rc );
    }


 rc2 = icaCloseAdapter( hHandle);  // Close the adapter


 if (rc)                                // Error getting AdapterID?
    return( mapSysErr(rc) );            //   Translate to Crypto error

 if (rc2)                               // Error closing?
    return( mapSysErr(rc2) );           //   Translate to Crypto error


 return(0);

}




/***********************************************************************
*
* icaOpenAdapter -
*
*     Public API to attach to Leeds.
*
*     Executes an 'Open' with permission level 0 (for normal apps.)
*
*     Input:    AdapterNum         = Adapter number
*
*     Output:   ICA_ADAPTER_HANDLE = Handle for the adapter
*
*     Returns:  UINT = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaOpenAdapter( icaAdapterNumber_t  AdapterNum,
                               ICA_ADAPTER_HANDLE *phAdapterHandle)
{

 ULONG   rc;
 HANDLE  hHandle;

 rc = openAdaptNum( AdapterNum, &hHandle );  // Open the specific adapter

 // printf("\nICADLL: icaOpenAdapter rc(%d)",rc);

 if (rc)
    return( mapSysErr(rc) );                 // Translate to Crypto error

 *phAdapterHandle = hHandle;
 return(0);


}







/***********************************************************************
*
* icaCloseAdapter -
*
*     Public API to give up access to a specific crypto adapter.
*
*     Input:    hAdapterHandle = handle for specific adapter
*
*     Output:   NONE
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaCloseAdapter(ICA_ADAPTER_HANDLE  hAdapterHandle)
{
   BOOLEAN  success;

   success = CloseHandle( (HANDLE) hAdapterHandle);

   if (!success)
      return( mapSysErr(GetLastError()) );   // Translate to Crypto error

   return(0);

}


/***********************************************************************
*
* icaRsaModExpo -
*
*     Public API to request the processing of a RSA Modulus Exponent
*     crypto transaction.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               inputDataLength = byte length of input data and must be
*                                 in range of 1 to 256 bytes, inclusive.
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pKeyModExpo     = pointer to key to be used for encrypt/decrypt
*               pOutputDataLength = byte length of the OutputData buffer and
*                                   at least as large as modulus byte length.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaRsaModExpo(ICA_ADAPTER_HANDLE    hAdapterHandle,
                             unsigned int          inputDataLength,
                             unsigned char         *pInputData,
                             ICA_KEY_RSA_MODEXPO   *pKeyModExpo,
                             unsigned int          *pOutputDataLength,
                             unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;

/*************************************
* Do some simple limit tests
* 1) inputDataLength must be in the range 1 to 256
* 2) All pointers must NOT be NULL
* 3) Output data length greater then or equal to
*    Modulus Byte length
* 4) keyType must be MODULUS_EXPONENT
**************************************/
 //
 //Check input data limit size
 //
 if ((inputDataLength < 1) || (inputDataLength > 256))
    return(HDDInvalidLength);
 //
 // Check for any pointer being NULL
 //
 if ((pInputData == NULL) || (pKeyModExpo == NULL) ||
     (pOutputDataLength == NULL) || (pOutputData == NULL))
    return(HDDInvalidParm);


 rc = verifyRSAModExpo(inputDataLength,*pOutputDataLength,pInputData,pKeyModExpo);
 if(rc)
 {
  printf("\n ICADLL: ERROR(0x%08lx)",rc);
  return(rc);
 }
/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = inputDataLength;
 requestBlk.ReqLen.length_2 = 0;
 requestBlk.ReqLen.length_3 = 0;
 requestBlk.ReqLen.length_4 = 0;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pKeyModExpo;
 requestBlk.ReqPtr.pBuffer_3 = NULL;
 requestBlk.ReqPtr.pBuffer_4 = NULL;
/**************************************
* Build the reply block
* Set the status before IOCTL call
***************************************/
 requestBlk.ReplyLen.length_1 = 0;
 requestBlk.ReplyLen.length_2 = 0;
 requestBlk.ReplyLen.length_3 = 0;
 requestBlk.ReplyLen.length_4 = 0;
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ReplyPtr.pBuffer_3 = NULL;
 requestBlk.ReplyPtr.pBuffer_4 = NULL;
/**************************************
* Preset the Status
***************************************/
 requestBlk.ica_status = HDDAccessDenied;


 // printf("\n ICADLL Ioctl--IOCTL_CRYPTO_RSA_ME ");

 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_RSA_ME,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,           // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
  {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_RSA_ME XACTION  rc = 0x%X", rc );
  }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}

/***********************************************************************
*
* icaRsaCrt -
*
*     Public API to request the processing of a RSA CRT decrypt
*     crypto transaction.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               inputDataLength = byte length of input data and must be
*                                 in range of 1 to 256 bytes, inclusive.
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pKeyCrt         = pointer to key to be used for decrypt
*               pOutputDataLength = byte length of the OutputData buffer and
*                                   at least as large as modulus byte length.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  LONG   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaRsaCrt(ICA_ADAPTER_HANDLE    hAdapterHandle,
                         unsigned int          inputDataLength,
                         unsigned char         *pInputData,
                         ICA_KEY_RSA_CRT       *pKeyModCrt,
                         unsigned int          *pOutputDataLength,
                         unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t   requestBlk;

/*************************************
* Do some simple limit tests
* 1) inputDataLength must be in the range 1 to 256
* 2) All pointers must NOT be NULL
* 3) Output data length greater then or equal to
*    Modulus Byte length
* 4) keyType must be KEYTYPE_PKCSCRT
**************************************/
 if ((inputDataLength < 1) || (inputDataLength > 256))
    return(HDDInvalidLength);
 if ((pInputData == NULL) || (pKeyModCrt == NULL) ||
     (pOutputDataLength == NULL) || (pOutputData == NULL))
    return(HDDInvalidParm);

 rc = verifyRSACrt(inputDataLength,*pOutputDataLength,pInputData,pKeyModCrt);
 if(rc)
 {
  printf("\n ICADLL: ERROR(0x%08lx)",rc);
  return(rc);
 }

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = inputDataLength;
 requestBlk.ReqLen.length_2 = 0;
 requestBlk.ReqLen.length_3 = 0;
 requestBlk.ReqLen.length_4 = 0;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pKeyModCrt;
 requestBlk.ReqPtr.pBuffer_3 = NULL;
 requestBlk.ReqPtr.pBuffer_4 = NULL;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyLen.length_1 = 0;
 requestBlk.ReplyLen.length_2 = 0;
 requestBlk.ReplyLen.length_3 = 0;
 requestBlk.ReplyLen.length_4 = 0;
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ReplyPtr.pBuffer_3 = NULL;
 requestBlk.ReplyPtr.pBuffer_4 = NULL;
/**************************************
* Preset the Status
***************************************/
 requestBlk.ica_status = HDDAccessDenied;



 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_RSA_CRT,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,           // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_RSA_CRT XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);


}

/***********************************************************************
*
* icaDes -
*
*     Public API to request the processing of a DES encrypt/decrypt
*     using single length key crypto transaction.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               mode            = specifies the operational mode and can be
*                                 MODE_DES_ECB or MODE_DES_CBC
*               dataLength      = byte length of input data, must be multiple of eight
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pIv             = pointer to to 8 byte initialization vector and
*                                 must contain a valid IV.
*               pKeyDes         = pointer to a single length(8 byte) key
*               pOutputDataLength = byte length of the OutputData buffer and
*                                   at least as large as input datalength.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  LONG   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaDes(ICA_ADAPTER_HANDLE    hAdapterHandle,
                      unsigned int          mode,
                      unsigned int          dataLength,
                      unsigned char         *pInputData,
                      ICA_DES_VECTOR        *pIv,
                      ICA_KEY_DES_SINGLE    *pKeyDes,
                      unsigned int          *pOutputDataLength,
                      unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;

/*************************************
* Do some simple limit tests
* 1) dataLength must be less then or equal
*    outputDataLength
* 2) datalength is multiple of 8 bytes
* 3) All pointers must NOT be NULL
**************************************/
 if (dataLength > *pOutputDataLength)
    return(HDDInvalidLength);
 if (dataLength & 0x07)
    return(HDDInvalidLength);
 if ((pInputData == NULL) || (pIv == NULL) ||
     (pKeyDes == NULL) || (pOutputDataLength == NULL) ||
     (pOutputData == NULL))
    return(HDDInvalidParm);

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = mode;
 requestBlk.ReqLen.length_2 = dataLength;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pIv;
 requestBlk.ReqPtr.pBuffer_3 = pKeyDes;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ica_status = HDDAccessDenied;



 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_DES,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,           // Driver to Userr data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_DES XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}

/***********************************************************************
*
* icaTDes -
*
*     Public API to request the processing of a DES encrypt/decrypt
*     using triple length key crypto transaction.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               mode            = specifies the operational mode and can be
*                                 MODE_DES_ECB or MODE_DES_CBC
*               dataLength      = byte length of input data
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pIv             = pointer to to 8 byte initialization vector and
*                                 must contain a valid IV.
*               pKeyDes         = pointer to a triple length(24 byte) key
*               pOutputDataLength = byte length of the OutputData buffer and
*                                   at least as large as input datalength.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaTDes(ICA_ADAPTER_HANDLE    hAdapterHandle,
                       unsigned int          mode,
                       unsigned int          dataLength,
                       unsigned char         *pInputData,
                       ICA_DES_VECTOR        *pIv,
                       ICA_KEY_DES_TRIPLE    *pKeyDes,
                       unsigned int          *pOutputDataLength,
                       unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;

/*************************************
* Do some simple limit tests
* 1) dataLength must be less then or equal
*    outputDataLength
* 2) datalength is multiple of 8 bytes
* 3) All pointers must NOT be NULL
**************************************/
 if (dataLength > *pOutputDataLength)
    return(HDDInvalidLength);
 if (dataLength & 0x07)
    return(HDDInvalidLength);
 if ((pInputData == NULL) || (pIv == NULL) ||
     (pKeyDes == NULL) || (pOutputDataLength == NULL) ||
     (pOutputData == NULL))
    return(HDDInvalidParm);

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = mode;
 requestBlk.ReqLen.length_2 = dataLength;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pIv;
 requestBlk.ReqPtr.pBuffer_3 = pKeyDes;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ica_status = HDDAccessDenied;



 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_TDES,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,             // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_TDES XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}

/***********************************************************************
*
* icaDesMac -
*
*     Public API to request the processing of a DES Message Authentication
*     Code(MAC) using triple length key crypto transaction. When the output
*     data length is less then 8(bytes) the ouput data will begin from the
*     left most result data upto the output data length.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               dataLength      = byte length of input data
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pIcv            = pointer to to 8 byte initialization vector and
*                                 must contain a valid IV.
*               pKeyDes         = pointer to a triple length(24 byte) key
*               pOutputDataLength = byte length of the OutputData buffer
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT ICA_CALL icaDesMac(ICA_ADAPTER_HANDLE     hAdapterHandle,
                        unsigned int           dataLength,
                        unsigned char          *pInputData,
                        ICA_DES_VECTOR         *pIcv,
                        ICA_KEY_DES_SINGLE     *pKeyDes,
                        unsigned int           *pOutputDataLength,
                        unsigned char          *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;

/*************************************
* Do some simple limit tests
* 1) dataLength and outputDataLength not zero
* 2) datalength is multiple of 8 bytes
* 3) All pointers must NOT be NULL
**************************************/
 if ((!dataLength) || (!(*pOutputDataLength)))
    return(HDDInvalidLength);
 if (dataLength & 0x07)
    return(HDDInvalidLength);
 if ((pInputData == NULL) || (pIcv == NULL) ||
     (pKeyDes == NULL) || (pOutputDataLength == NULL) ||
     (pOutputData == NULL))
    return(HDDInvalidParm);

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = dataLength;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pIcv;
 requestBlk.ReqPtr.pBuffer_3 = pKeyDes;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ica_status = HDDAccessDenied;



 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_MAC,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,             // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_MAC XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}

/***********************************************************************
*
* icaTDesMac -
*
*     Public API to request the processing of a DES Message Authentication
*     Code(MAC) using triple length key crypto transaction. When the output
*     data length is less then 8(bytes) the ouput data will begin from the
*     left most result data upto the output data length
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               dataLength      = byte length of input data
*               pInputData      = pointer to input data to be encrypted/decrypted
*               pIcv            = pointer to to 8 byte initialization vector and
*                                 must contain a valid IV.
*               pKeyDes         = pointer to a triple length(24 byte) key
*               pOutputDataLength = byte length of the OutputData buffer
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
 UINT ICA_CALL icaTDesMac(ICA_ADAPTER_HANDLE     hAdapterHandle,
                         unsigned int            dataLength,
                         unsigned char           *pInputData,
                         ICA_DES_VECTOR          *pIcv,
                         ICA_KEY_DES_TRIPLE      *pKeyDes,
                         unsigned int            *pOutputDataLength,
                         unsigned char           *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;

/*************************************
* Do some simple limit tests
* 1) dataLength and outputDataLength not zero
* 2) datalength is multiple of 8 bytes
* 3) All pointers must NOT be NULL
**************************************/
 if ((!dataLength) || (!(*pOutputDataLength)))
    return(HDDInvalidLength);
 if (dataLength & 0x07)
    return(HDDInvalidLength);
 if ((pInputData == NULL) || (pIcv == NULL) ||
     (pKeyDes == NULL) || (pOutputDataLength == NULL) ||
     (pOutputData == NULL))
    return(HDDInvalidParm);


/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = dataLength;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pIcv;
 requestBlk.ReqPtr.pBuffer_3 = pKeyDes;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ica_status = HDDAccessDenied;



 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_TMAC,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,             // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_TMAC XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}

/***********************************************************************
*
* icaSha1 -
*
*     Public API to request the processing of a FIPS 180-1 Secure Hash
*     Algorithim transaction.
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               shaMessagePart  = ONLY,FIRST,MIDDLE or FINAL part of message
*               inputDataLength = byte length of input data, must be greater then 0
*               pInputData      = pointer to input data to be SHA(ed)
*               shaContextLength= length of the SHA-1 message context and must
*                                 be at least 28 bytes.
*               pShaContext     = pointer to a SHA-1 context. Used by the I/O
*                                 subsystem to store intermediate values when
*                                 chaining is used.
*               pOutputDataLength = byte length of the OutputData buffer. This
*                                   parameter must be at least 20 bytes.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputDataLength = updated to indicate actual result byte length
*               pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaSha1(ICA_ADAPTER_HANDLE    hAdapterHandle,
                       unsigned int          shaMessagePart,
                       unsigned int          inputDataLength,
                       unsigned char         *pInputData,
                       unsigned int          shaContextLength,
                       SHA_CONTEXT           *pShaContext,
                       unsigned int          *pOutputDataLength,
                       unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;


/*************************************
* Do some simple limit tests
* 1) Is the shaMessagePart Valid
* 2) inputDataLength must be greater the 0
* 3) shaContextLength must be at least 28
* 4) All pointers must NOT be NULL
* 5) *pOutputDataLength must be at least 20
**************************************/
 if ((shaMessagePart < SHA_MSG_PART_ONLY) ||
     (shaMessagePart > SHA_MSG_PART_FINAL))
    return(HDDInvalidParm);
 if (inputDataLength <= 0)
    return(HDDInvalidLength);
 if (shaContextLength < LENGTH_SHA_CONTEXT)
    return(HDDInvalidLength);
 if ((pShaContext == NULL) || (pOutputDataLength == NULL) ||
     (pOutputData == NULL))
    return(HDDInvalidParm);
 if (*pOutputDataLength < LENGTH_SHA_HASH)
    return(HDDInvalidLength);

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1 = shaMessagePart;
 requestBlk.ReqLen.length_2 = inputDataLength;
 requestBlk.ReqLen.length_3 = shaContextLength;
 requestBlk.ReqPtr.pBuffer_1 = pInputData;
 requestBlk.ReqPtr.pBuffer_2 = pShaContext;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyPtr.pBuffer_1 = pOutputDataLength;
 requestBlk.ReplyPtr.pBuffer_2 = pOutputData;
 requestBlk.ica_status = HDDAccessDenied;


 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_SHA,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,             // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_SHA XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}


/***********************************************************************
*
* icaRandomNumberGenerate -
*
*     Public API to request the random numbers
*
*     This call is used to send and receive data between an
*     application in the host and the crypto adapter.
*     The calling thread will remain blocked until the transaction is
*     completed
*
*     Input:    hAdapterHandle  = handle for specific adapter
*               outputDataLength = byte length of the OutputData buffer.
*               pOutputData     = pointer to output data buffer
*
*     Output:   pOutputData     = pointer to output data buffer
*
*     Returns:  UINT   = Error code.  (0 = No error)
*
***********************************************************************/
UINT  ICA_CALL icaRandomNumberGenerate(ICA_ADAPTER_HANDLE    hAdapterHandle,
                                       unsigned int          outputDataLength,
                                       unsigned char         *pOutputData)
{

 ULONG   rc=0;
 ULONG   cbReturned;
 ULONG   success;
 icaRB_t  requestBlk;


/*************************************
* Do some simple limit tests
* 1) All pointers must NOT be NULL
* 2) outputDataLength must be greater the 0
**************************************/
 if (pOutputData == NULL)
    return(HDDInvalidParm);
 if (outputDataLength <= 0)
    return(HDDInvalidLength);

 printf("\n ICADLL: RN outputDataLength(0x%08lx)",outputDataLength);
 printf("\n ICADLL: RN outputDataLength(0x%08lx)",pOutputData);

/**************************************
* Build the request block
***************************************/
 requestBlk.ReqLen.length_1  = outputDataLength;
 requestBlk.ReqLen.length_2 = 0;
 requestBlk.ReqLen.length_3 = 0;
 requestBlk.ReqLen.length_4 = 0;
 requestBlk.ReqPtr.pBuffer_1 = pOutputData;
 requestBlk.ReqPtr.pBuffer_2 = NULL;
 requestBlk.ReqPtr.pBuffer_3 = NULL;
 requestBlk.ReqPtr.pBuffer_4 = NULL;
/**************************************
* Build the reply block
***************************************/
 requestBlk.ReplyLen.length_1 = outputDataLength;
 requestBlk.ReplyLen.length_2 = 0;
 requestBlk.ReplyLen.length_3 = 0;
 requestBlk.ReplyLen.length_4 = 0;
 requestBlk.ReplyPtr.pBuffer_1 = pOutputData;
 requestBlk.ReplyPtr.pBuffer_2 = NULL;
 requestBlk.ReplyPtr.pBuffer_3 = NULL;
 requestBlk.ReplyPtr.pBuffer_4 = NULL;
 requestBlk.ica_status = HDDAccessDenied;


 success = DeviceIoControl( hAdapterHandle,
                            (ULONG) IOCTL_CRYPTO_RNG,
                            &requestBlk,           // User to driver data
                            sizeof(icaRB_t),
                            &requestBlk,           // Driver to user data
                            sizeof(icaRB_t),
                            &cbReturned,           // Count of bytes returned
                            NULL );                // NULL = Thread blocks

 if (!success)
    {
    rc = GetLastError();
    // printf("\n Error on IOCTL_CRYPTO_RNG XACTION  rc = 0x%X", rc );
    }


 if (rc)
    return( mapSysErr(rc) );            // Translate rc to Crypto error



 return(requestBlk.ica_status);

}



